#!/bin/bash
clear
echo -e "\e[93m\e[1mERK to HDDKEY wersja_test_gówna_2\n"
echo -e "\e[0mThis simple script will generate \e[92m\e[1mHDD Key\e[0m & \e[92m\e[1mENDEC Key\e[0m from \e[92m\e[1mEID Root Key\e[0m."
echo -e "Remember that you need ERK from console which you want mount/decrypt HDD."
echo -e "You \e[1m\e[91mcannot\e[0m use different ERK!\n"
echo -e "\e[93m\e[1mStep 1: \e[0mInstall \e[92m\e[1mdd\e[0m, \e[92m\e[1mxdd\e[0m and \e[92m\e[1mopenssl\e[0m."
echo -e "\e[93m\e[1mStep 2: \e[0mPlace your \e[92m\e[1meid_root_key\e[0m in path from where you run this script."
echo -e "\e[93m\e[1mStep 3: \e[0mPlace \e[92m\e[1mata_data_seed\e[0m, \e[92m\e[1mata_tweak_seed\e[0m, \e[92m\e[1mendec_data_seed\e[0m, \e[92m\e[1mendec_tweak_seed\e[0m"
echo -e "        in path from where you run this script (in binary form)."
echo -e "\e[93m\e[1mStep 4: \e[0mChoose for what model you want the keys:"
opcje=(
	"Fat"
	"Slim"
	"oh, nevermind... ;)"
	)
select wybierz in "${opcje[@]}"
do
	case $wybierz in

		"Fat")
			# erk=$(xxd -p -u -c 48 "eid_root_key")
			erk_data=$(xxd -p -u -c 32 -l 32 "eid_root_key")
			erk_iv=$(xxd -p -u -c 16 -s -16 "eid_root_key")
			openssl aes-192-cbc -e -in "ata_data_seed" -out "ata_data_key" -K $erk_data -iv 0000000000000000 -nopad -nosalt
			openssl aes-192-cbc -e -in "ata_tweak_seed" -out "ata_tweak_key" -K $erk_data -iv 0000000000000000 -nopad -nosalt
			openssl aes-128-cbc -e -in "endec_data_seed" -out "endec_data_key" -K $erk_data -iv 0000000000000000 -nopad -nosalt
			openssl aes-128-cbc -e -in "endec_tweak_seed" -out "endec_tweak_key" -K $erk_data -iv 0000000000000000 -nopad -nosalt
			adk=$(xxd -p -u -c 24 -l 24 ata_data_key)
			atk=$(xxd -p -u -c 24 -l 24 ata_tweak_key)
			edk=$(xxd -p -u -c 16 -l 16 endec_data_key)
			etk=$(xxd -p -u -c 16 -l 16 endec_tweak_key)
			echo "$adk" "$atk" | xxd -r -p > hdd_key.bin
			echo "$edk" "$etk" | xxd -r -p > vflash_key.bin
			echo -e "\n"
			break
			;;

		"Slim")
			# erk=$(xxd -p -u -c 48 "eid_root_key")
			erk_data=$(xxd -p -u -c 32 -l 32 "eid_root_key")
			erk_iv=$(xxd -p -u -c 16 -s -16 "eid_root_key")
			# dd if="eid_root_key" of="erk_data" bs=1 count=32
			# dd if="eid_root_key" of="erk_iv" bs=1 count=16 skip=32
			openssl aes-128-xts -e -in "ata_data_seed" -out "ata_data_key" -K $erk_data -iv $erk_iv -nopad -nosalt
			openssl aes-128-xts -e -in "ata_tweak_seed" -out "ata_tweak_key" -K $erk_data -iv $erk_iv -nopad -nosalt
			openssl aes-128-xts -e -in "endec_data_seed" -out "endec_data_key" -K $erk_data -iv $erk_iv -nopad -nosalt
			openssl aes-128-xts -e -in "endec_tweak_seed" -out "endec_tweak_key" -K $erk_data -iv $erk_iv -nopad -nosalt
			adk=$(xxd -p -u -c 16 -l 16 ata_data_key)
			atk=$(xxd -p -u -c 16 -l 16 ata_tweak_key)
			edk=$(xxd -p -u -c 16 -l 16 endec_data_key)
			etk=$(xxd -p -u -c 16 -l 16 endec_tweak_key)
			echo "$adk" "$atk" | xxd -r -p > hdd_key.bin
			echo "$edk" "$etk" | xxd -r -p > vflash_key.bin
			echo -e "\n"
			break
			;;

		"oh, nevermind... ;)")
			break
			;;

		*) echo invalid option;;
	esac
done

# SLIM
# XTS-AES-128 is used to encrypt all data on PS3 HDD.
# XTS is NOT CBC!!! It's AES-ECB with tweak XORing. AES-CBC is impractical for HDD encryption. Each sector can be encrypted/decrypted independantly from other HDD sectors.
# Good paper about XTS-AES: http://ntnu.diva-portal.org/smash/get/diva2:347753/FULLTEXT01
# VFLASH is encrypted twice. First with ENCDEC keys and then with ATA keys.
# Tweak and data XTS keys are of size 32 bytes but only the first 16 bytes are used.

# FAT
# On the PHAT consoles AES-CBC-192 is used for HDD encryption and AES-CBC-128 for VFLASH encryption.
# So no tweak and tweak key here. Each sector is encrypted with the same zeroed IV.
# VFLASH is encrypted once with ENCDEC key and zeroed IV!
# Data key is of size 32 bytes but only the first 24 bytes are used for HDD and 16 bytes for VFLASH.

